// C Header File
// Created 1/1/01
// Updated 12/28/06; 8:37:58 PM

#define SAVE 1
#define LOAD 0

HANDLE VAThandle;
int buff[1];
char *buffer = NULL;
int NewFile=0;


short AlphaUnlock(short x, long y);
unsigned char ChooseLevelEntry(char *sptr);
HANDLE CreateFile(char *BUFFER,short changed);
short DialogInteractive(short Message, long Value);
void EditorFiler(char *FileName,short changed);
int FileCount();
char GetLevelFileNames(int h,int mode);
int GetLevelInfoDialog();
void InitializeFile();
int IsLevelFile(HANDLE h);
int LoadFileDialog(char *fname, char FileOpen);
char LoadFile(char *fname, char FileStatus);
HANDLE ModifyFile(char *BUFFER,short changed);
void OpenFile(char *BUFFER);
void PromptChamp();
void ReadFile(char *sptr);
int SaveFileDialog(char *BUFFER);
void SetAlphaLockAddr();
char Skip(char offset);
void WriteRecord();
void WriteToFile(char *sptr,unsigned char levels,unsigned char maxlevel,short changed);

void EditorFiler(char *FileName, short changed)
{
 char *sptr,*dptr;
 char fname[]={"            "};  // 12 spaces
 if (DlgMessage("Laser Tank Level Filer","Level not saved, SAVE DATA?",BT_YES,BT_NO)==13)
 {
  if (GetLevelInfoDialog()==13)
  {
   NewFile=0;
   if (SaveFileDialog(fname)==13)
   {
    if (NewFile)
    {
     if (CreateFile(fname,changed))
     {
      dptr=FileName;
      sptr=fname;
      while(*dptr++=*sptr++	);	
     }	
    } 
    else
    {
     if (ModifyFile(fname,changed))
     {
      dptr=FileName;
      sptr=fname;
      while(*dptr++=*sptr++);
     }
    }
   }    
  }
 }
}

void InitializeFile()
{
 if (FileCount()==0)
 {
  memcpy(board,original,192);
  CreateFile("laser",True);	
 }
}

char LoadFile(char *fname, char FileStatus)
{
 char Thefile[] = {"            "};  //10 spaces;
 char *dptr,*sptr;
 if (LoadFileDialog(Thefile,FileStatus)==13)
 { 
  dptr=fname;
  sptr=&Thefile[0];
  while(*dptr++=*sptr++); 
  Level=0;
  return 1;
 } 
 else
  return 0;
}

void SetAlphaLockAddr()
{
 char code[]={"              "};  // 15 spaces
 AB_prodid(code);
 switch (code[5])
 {
  case 48:
   AlphaLockAddr=0x75AD; AMSversion=1; break;  //Alpha Lock toggle Address for 1.00
  case 51:
   AlphaLockAddr=0x75B5; AMSversion=1; break;  //Alpha Lock toggle Address for 1.05       
  case 53:
   AlphaLockAddr=0x79B1; AMSversion=2; break;  //Alpha Lock toggle Address for 2.01
  case 55:
   AlphaLockAddr=0x79B5; AMSversion=2; break;  //Alpha Lock toggle Address for 2.03
  case 56:
   AlphaLockAddr=0x6499; AMSversion=2; break;  //Alpha Lock toggle Address for 2.04
  case 57:
   AlphaLockAddr=0x649D; AMSversion=2; break;  //Alpha Lock toggle Address for 2.05
  default:
   AlphaLockAddr=0; AMSversion=1;
 }
}

char GetLevelFileNames(int h, int mode)
{
 int i;
 int size;
 //char *folder = "          ";  //10 spaces
 char *ptr1,*ptr2;
 char *FileBuffer = "             "; //14 spaces
 char ThisFile;
 SYM_ENTRY *SymPtr;
 i=1;
 ThisFile=0;
 //*folder=0;
 switch (mode)
 {
  case SAVE:
   PopupAddText(h,-1,"New File",0);
   i=1; break;
  case LOAD:
   i=0; break;
 }
 FolderGetCur(FileBuffer);
 //while(*++folder = *FileBuffer++);
 size=FileCount();
 buffer=malloc((size+2)*9);
 memset(buffer,0,(size+2)*9);
 SymPtr=SymFindFirst(SYMSTR(FileBuffer),FO_SINGLE_FOLDER);
 while (SymPtr)
 {
  if (IsLevelFile(SymPtr->handle))
  {
   ptr2=SymPtr->name;
   if (strstr(ptr2,LevFile)) ThisFile=i+1;
   ptr1=&buffer[9*i];
   while(*ptr1++=*ptr2++);
   PopupAddText(h,-1,&buffer[9*i],0);   
   i++;
  }
  SymPtr=SymFindNext();
 }
 if (i==1) NewFile=1;
 return ThisFile;
}

int FileCount()
{
 int i;
 //char *folder = "          ";  //10 Spaces
 char *FileBuffer = "              ";  // 14 spaces
 SYM_ENTRY *SymPtr;
 i=0;
 //*folder=0;
 FolderGetCur(FileBuffer);
 //while(*++folder = *FileBuffer++);
 SymPtr=SymFindFirst(SYMSTR(FileBuffer), FO_SINGLE_FOLDER);
 while (SymPtr)
 {
  if (IsLevelFile(SymPtr->handle))
   i++;
  SymPtr=SymFindNext();
 }
 return i;
}

int IsLevelFile(HANDLE h)
{
 int status;
 unsigned char TypTag;
 char *sptr;
 TypTag = *(unsigned char*) HToESI(h);
 switch (TypTag)
 {
  case OTH_TAG:
   sptr = HToESI(h); sptr-=4;
   if (strcmp("LVL\0",sptr)==0)
    status=1;
   else status=0;
   break;
  default:
   status=0;
 }
 return status;
}

int SaveFileDialog(char *BUFFER)
{               
 int ok;
 int key;
 int itemoff;
 int handle1=0;
 int handle2=0;
 char *ptr;
 handle1 = DialogNew(130,50,(DialogNew_t) DialogInteractive);   
 handle2 = PopupNew("Current Level Files",70);
 buff[0]=GetLevelFileNames(handle2,SAVE); 
 DialogAddTitle(handle1,"Laser Tank Level Filer",BT_OK,BT_CANCEL);
 DialogAddPulldown(handle1,4,15,"Level Files:",handle2,0);
 DialogAddRequest(handle1,4,27,"File Name:",0,8,9);
 ok=0;
 while (ok==0)
 {
  key=DialogDo(handle1,CENTER,CENTER,buffer,buff);
  itemoff=9*(buff[0]-1);
  if (key==13)
   {	
    if (buffer[itemoff]>=97 && buffer[itemoff]<=122)
     key=DlgMessage("Save file as",&buffer[itemoff],BT_OK,BT_NO);
    else
     key=264; 
    if (key==13)
    {
     ptr=&buffer[itemoff];
     while(*BUFFER++=*ptr++)    	
     ok=13;
    }
    else ok=0; 
   }
  else
   ok=264;
 }  
 HeapFree(handle2);
 HeapFree(handle1);
 free(buffer);
 return ok;
}

int LoadFileDialog(char *fname, char FileOpen)
{               
 int key;
 int handle1=0;
 int handle2=0;
 char *sptr,*dptr;
 handle1 = DialogNewSimple(130,40);
 handle2 = PopupNew("Current Level Files",70);
 buff[0]=GetLevelFileNames(handle2,LOAD); 
 if (FileOpen==True)
	 DialogAddTitle(handle1,"Laser Tank Level Filer",BT_OK,BT_CANCEL);
 else
 	 buff[0]=1;
	 DialogAddTitle(handle1,"Laser Tank Level Filer",BT_OK,BT_NONE); 
 DialogAddPulldown(handle1,4,15,"Level Files:",handle2,0);
 key=DialogDo(handle1,CENTER,CENTER,NULL,buff);
 if (key==13) 
 {
  dptr=fname;
  sptr=&buffer[9*(buff[0]-1)];
  while (*dptr++=*sptr++);
  OpenFile(fname);
 }
 HeapFree(handle1);
 HeapFree(handle2);
 free(buffer);
 return key;
}

int GetLevelInfoDialog()
{               
 int key;
 int i;
 int handle1=0;
 int handle2=0;
 char charbuffer[45];
 char *sptr,*dptr;
 handle1 = DialogNewSimple(150,62);
 handle2 = PopupNew("Difficulty",78);
 for (i=0;i<=4;i++)
  PopupAddText(handle2,-1,&dif[8*i],0);
 memset(charbuffer,0,45);
 sptr=&title[0];
 dptr=&charbuffer[0];
 while (*dptr++=*sptr++);
 sptr=&author[0];
 dptr=&charbuffer[21];
 while (*dptr++=*sptr++);
 buff[0]=difficulty+1;
 DialogAddTitle(handle1,"Laser Tank Level Info",BT_OK,BT_CANCEL);
 DialogAddRequest(handle1,4,15,"Level Name",0,20,16);
 DialogAddRequest(handle1,4,28,"Author",21,20,16);
 DialogAddPulldown(handle1,4,41,"Difficulty:",handle2,0);
 key=DialogDo(handle1,CENTER,CENTER,charbuffer,buff);
 sptr=&charbuffer[0];
 dptr=&title[0];
 while(*dptr++=*sptr++);
 sptr=&charbuffer[21];
 dptr=&author[0];
 while(*dptr++=*sptr++);
 difficulty=buff[0]-1;
 HeapFree(handle1);
 HeapFree(handle2);
 return key;
}

short DialogInteractive(short Message, long Value)
{
 int returnvalue;
 returnvalue=1;
 if (Message==1)
 {
  returnvalue=-4;
  if (Value==1) 
   NewFile=1;
  else
   NewFile=0;
  }
 if (Message==-2 && Value==2) 
 {
  returnvalue=NewFile;
 }
 return returnvalue;
}

HANDLE ModifyFile(char *BUFFER, short changed)
{
 SYM_ENTRY *sym_entry;
 HANDLE h;
 //char *hptr="          "; //10 spaces
 unsigned char *sptr;
 unsigned char maxlevel;
 //*hptr=0;
 //while (*++hptr=*BUFFER++);
 EM_moveSymFromExtMem(SYMSTR(BUFFER),HS_NULL);          //SYMSTR(BUFFER) was hptr
 if (!(sym_entry=DerefSym(SymFind(SYMSTR(BUFFER)))))   // SYMSTR(BUFFER) was hptr
  return H_NULL;
 sptr = (char*) HLock(sym_entry->handle);
 Level = ChooseLevelEntry(sptr);
 maxlevel=sptr[2]-1;
 if (Level>maxlevel)
 {
  HeapUnlock(sym_entry->handle);
  h=HeapRealloc(sym_entry->handle,FSIZE*(Level+1)+9);
  sptr = (char*) HLock(sym_entry->handle=h);
  maxlevel=Level;
 }
 WriteToFile(sptr,Level,maxlevel,changed);
 HeapUnlock(sym_entry->handle);
 EM_moveSymToExtMem(SYMSTR(BUFFER),HS_NULL);    //SYMSTR(BUFFER) was hptr
 return sym_entry->handle;
}

HANDLE CreateFile(char *BUFFER, short changed)
{
 HANDLE h;
 SYM_ENTRY *sym_entry;
 //char *hptr="          "; // 10 spaces
 char *sptr;
 //*hptr=0;
 //while (*++hptr=*BUFFER++);
 if (!(h=HeapAlloc(FSIZE+9))) return H_NULL;
 if (!(sym_entry=DerefSym(SymAdd(SYMSTR(BUFFER)))))   //symstr(buffer)  was hptr 
 {
  HeapFree(h);
  return H_NULL;
 }
 sptr = (char*) HLock(sym_entry->handle=h);
 WriteToFile(sptr,0,0,changed);
 HeapUnlock(h);
 EM_moveSymToExtMem(SYMSTR(BUFFER),HS_NULL);
 return h;
}

unsigned char ChooseLevelEntry(char *sptr)
{
 char *vptr;
 unsigned char TopLevel;
 unsigned char SaveLevel;
 int handle3=0;
 char *levbuf= "     ";
 char *text1 = "         ";  // 10 spaces
 char *text2 = "           ";  // 12 spaces
 sprintf(levbuf,"%u",Level);
 vptr=sptr+2;
 TopLevel=*vptr-1;
 handle3=DialogNew(130,50,(DialogNew_t) AlphaUnlock);     //AlphaUnlock
 DialogAddTitle(handle3,"Laser Tank Level Filer",BT_SAVE,BT_CANCEL);
 DialogAddText(handle3,4,15,"Enter the Level number to");
 DialogAddRequest(handle3,4,27,"SAVE:",0,3,5);
 sprintf(text1,"0 - %u ",TopLevel);
 sprintf(text2,"%u = Add",TopLevel+1);
 DialogAddText(handle3,90,23,text1);
 DialogAddText(handle3,90,31,text2);
 DialogDo(handle3,CENTER,CENTER,levbuf,NULL);
 SaveLevel = (unsigned char) atoi(levbuf);
 HeapFree(handle3);
 if (SaveLevel>TopLevel+1) SaveLevel=TopLevel+1;
 Level=SaveLevel;
 return SaveLevel;
}

//short AlphaUnlock(short x, long y)
//{
// if (AMSversion==2 && x==-2 && y==1)
//  poke(AlphaLockAddr,0);
// return 1;
//}

short AlphaUnlock(short x, long y)
{
  char *AlphaLockSaveState = " ";
	if (x==-2 && y==1)
	{
		if (AlphaLockAddr == 0)
	  	_rom_call(void,(char*),482)(AlphaLockSaveState);
	  else
	  	poke(AlphaLockAddr,0);
	}
	return 1;
}

char Skip(char offset)
{
 short lev;
 SYM_ENTRY *sym_entry;
 char status,*sptr,*aptr,*bptr,*lptr;
 aptr=charbuffer;
 *aptr=0;
 bptr=&LevFile[0];
 status=0;
 while(*++aptr=*bptr++);
 sym_entry=DerefSym(SymFind(aptr));
 sptr = (char*) HLock(sym_entry->handle);
 memset(charbuffer,32,78);
 charbuffer[78]=0;
 lev=Level;
 lev+=offset;
 if (lev>=0 && lev<sptr[2]) 
 {
  lptr=&sptr[3+FSIZE*lev];
  difficulty= *lptr;
  aptr=&lptr[1];
  bptr=&title[0];
  while (*bptr++=*aptr++);
  aptr=&lptr[22];
  bptr=&author[0];
  while (*bptr++=*aptr++);
  aptr=&lptr[51];
  bptr=&champ[0];
  while (*bptr++=*aptr++);
  GlobalMoves=*(unsigned*) &lptr[43];
  GlobalShots=*(unsigned*) &lptr[45];
  BestMoves=*(unsigned*) &lptr[47];
  BestShots=*(unsigned*) &lptr[49];
  memmove(board,&lptr[58],192);
  Level=lev;
  status=1;
 }
 HeapUnlock(sym_entry->handle);
 return status;
}

void PromptChamp()
{               
 int key;
 int handle1=0;
 char *charbuff="        ";
 char *sptr,*dptr;
 sptr=user;
 dptr=charbuff;
 while (*dptr++=*sptr++);
 handle1 = DialogNewSimple(130,40);
 DialogAddTitle(handle1,"Enter the Hall of Fame",BT_OK,BT_NONE);
 DialogAddRequest(handle1,4,17,"Your Name:",0,6,6);
 key=DialogDo(handle1,CENTER,CENTER,charbuff,NULL);
 dptr=champ;
 sptr=charbuff;
 while (*dptr++=*sptr++);
 dptr=user;
 sptr=charbuff;
 while (*dptr++=*sptr++);
 HeapFree(handle1);
}

void WriteRecord(char *FileName)
{
 unsigned lev;
 SYM_ENTRY *sym_entry;
 char *sptr,*aptr,*bptr,*lptr;
 char *chptr="            "; //12 spaces
 aptr=charbuffer;
 *aptr=0;
 while(*++aptr=*FileName++);
 EM_moveSymFromExtMem(aptr,HS_NULL);
 sym_entry=DerefSym(SymFind(aptr));
 sptr = (char*) HLock(sym_entry->handle);
  lev=Level;
 lptr=&sptr[3+FSIZE*lev];
 chptr=&lptr[51];
 bptr=&champ[0];
 while (*chptr++=*bptr++);
 *(unsigned*) &lptr[43]=GlobalMoves;
 *(unsigned*) &lptr[45]=GlobalShots;
 *(unsigned*) &lptr[47]=BestMoves;
 *(unsigned*) &lptr[49]=BestShots;
 HeapUnlock(sym_entry->handle);
 EM_moveSymToExtMem(aptr,HS_NULL);
}

void OpenFile(char *BUFFER)
{
 SYM_ENTRY *sym_entry;
 char *hptr="               ";  // 15 spaces
 //char *fptr;
 unsigned char *sptr;
 *hptr=0;
 //fptr=&BUFFER[0];
 //while (*++hptr=*fptr++);
 sym_entry=DerefSym(SymFind(SYMSTR(BUFFER)));     //SYMSTR(BUFFER) was hptr
 sptr = (char*) HLock(sym_entry->handle);
 ReadFile(sptr);
 HeapUnlock(sym_entry->handle);
}

void WriteToFile(char *sptr, unsigned char curlevel, unsigned char maxlevel, short changed)
{
 char *vptr,*eptr,*dptr,*lptr;
 *(unsigned*) sptr=(maxlevel+1)*FSIZE+7;
 sptr[2]=maxlevel+1;
 eptr=sptr+3+(maxlevel+1)*FSIZE;
 eptr[0]=0;
 eptr[1]= 76;
 eptr[2]= 86;
 eptr[3]= 76;
 eptr[4]=0;
 eptr[5]=248;
 lptr=&sptr[3+FSIZE*curlevel];
 memset(lptr,0,FSIZE-1);
 lptr[0]=difficulty;
 dptr=&title[0];
 vptr=&lptr[1];
 while(*vptr++=*dptr++);
 dptr=&author[0];
 vptr=&lptr[22];
 while(*vptr++=*dptr++);
 if (changed)
  memset(&lptr[43],0,14);
 else
 {
 	*(unsigned*) &lptr[43]=GlobalMoves;
 	*(unsigned*) &lptr[45]=GlobalShots;
  *(unsigned*) &lptr[47]=BestMoves;
  *(unsigned*) &lptr[49]=BestShots;
 }
 vptr=&lptr[51];
 if (changed)
  memset(vptr,0,6);
 else
 {
  dptr=&champ[0];
  while(*vptr++=*dptr++);
 }
 memcpy(&lptr[58],board,192);
}

void ReadFile(char *sptr)
{
 char *vptr,*dptr,*lptr,level=0;
 lptr=&sptr[3+level*FSIZE];
 difficulty=lptr[0];
 dptr=&title[0];
 vptr=&lptr[1];
 while(*dptr++=*vptr++);
 dptr=&author[0];
 vptr=&lptr[22];
 while(*dptr++=*vptr++);
 GlobalMoves=*(unsigned*) &lptr[43];
 GlobalShots=*(unsigned*) &lptr[45];
 BestMoves=*(unsigned*) &lptr[47];
 BestShots=*(unsigned*) &lptr[49];
 dptr=&champ[0];
 vptr=&lptr[51];
 while(*dptr++=*vptr++);
 memcpy(board,&lptr[58],192);
}
